<?php
namespace Fiscal\Logic\NotaFiscal\Exceptions;
/**
 * Created by JetBrains PhpStorm.
 * User: maximiliansilva
 * Date: 21/01/13
 * Time: 16:59
 * To change this template use File | Settings | File Templates.
 */
use \Geral\Util\AcumuladorDeMensagens;
class NFEntradaException extends \Fiscal\Logic\Exception
{
    private $messageName;


    public function __construct($messagemName){
        parent::__construct($messagemName);
        $this->messageName = $messagemName;
    }

    public function getMessageName()
    {
        return $this->messageName;
    }

    public static function fornecedorNaoPermitidoLancarNF(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_fornecedor_nao_permitido_lancar_nf');
        return false;
    }

    public static function dataIntegracaoAgente2bInvalida(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_data_integracao_agente2b_invalida');
        return false;
    }

    public static function produtoInativoFilial(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_produtoInativo_filial');
        return false;
    }

    public static function produtoNaoRelacionadoFilial(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_produtoNaoRelacionadoFilial');
        return false;
    }

    public static function inventarioPendenteFilial(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_inventarioPendenteFilial');
        return false;
    }

    public static function notafiscalCompraNaoPossuiAF(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_notafiscal_compra_nao_possui_af');
        return false;
    }

    public static function dataEntradaForaPeriodo(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_data_entrada_fora_periodo');
        return false;
    }

    public static function dataSaidaForaPeriodo(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_data_saida_fora_periodo');
        return false;
    }

    public static function fornecedorInativo(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_fornecedor_inativo');
        return false;
    }

    public static function permiteFornecedorCotacaoCompra(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_permite_fornecedor_cotacao_compra');
        return false;
    }

    public static function fornecedorUtilizaIntegracao(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_fornecedor_utiliza_integracao');
        return false;
    }

    public static function dataEmissaoBloqueada(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_data_emissao_bloqueada');
        return false;
    }

    public static function dataEmissaoMaiorDataEntrada(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_data_emissao_maior_data_entrada');
        return false;
    }

    public static function XMLJaCadastrado(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_XMLJaCadastrado');
        return false;
    }
    
    public static function filiaLogadaIgualFilialInformada(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_filiaLogadaIgualFilialInformada');
        return false;
    }

    public static function notaFiscalJaCadastrada(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_NFJaCadastrada');
        return false;
    }
    
    public static function numeroNFdeveSerInformado(){
    	AcumuladorDeMensagens::getInstance()->addMensagem('msg_numeroNFdeveSerInformado');
    	return false;
    }

    public static function serieDeveSerInformada(){
    	AcumuladorDeMensagens::getInstance()->addMensagem('msg_serieDeveSerInformada');
    	return false;
    }

    public static function dataEmissaoForaPeriodo(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_data_emissao_fora_periodo');
        return false;
    }

    public static function existeOcorrenciaAtendimento($param){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_existe_ocorrencia_atendimento', array($param));
        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
    }

    public static function notafiscalEmetidaOuAprovado(){
        AcumuladorDeMensagens::getInstance()->addMensagem('msg_notafiscal_emetida_ou_aprovado');
        throw new self(AcumuladorDeMensagens::ID_ACUMULADOR_DE_MENSAGENS);
    }
    
    public static function qtItemDevolverMenorIgualQtOriginal($quantidade){
    	AcumuladorDeMensagens::getInstance()->addMensagem('msg_qtItemDevolverMenorIgualQtOriginal', array($quantidade));
    	return false;
    }
    
    public static function qtItemDevolverMenorIgualQtOrigem(){
    	AcumuladorDeMensagens::getInstance()->addMensagem('msg_qtItemDevolverMenorIgualQtOrigem');
    	return false;
    }
}
