-- ==================================================================== --
-- SISTEMA     : PONTO DE VENDA                                         --
-- OBJETIVOS   : Atualiza os saldos dos tickets                         --
-- Programador : Leonardo Antnio                                       --
-- Convertida  : 01/12/2003                                             --
-- @C:\WIN_V3\SQL\SQLSERVER\3800_PDVSTP_ATUALIZA_SALDO_TICKET.SQL       --
-- ==================================================================== --

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
  	        O.NAME = 'ATUALIZA_SALDO_TICKET'  AND
	        TYPE = 'P' 			  AND
	        U.UID = O.UID             	  AND
	        U.NAME = USER)

  DROP PROCEDURE ATUALIZA_SALDO_TICKET
  GO

CREATE PROCEDURE ATUALIZA_SALDO_TICKET
  @P_CDFILIAL VARCHAR (4),
  @P_CDLOJA   VARCHAR (10),
  @P_DATA     DATETIME

AS

  DECLARE @V_DTCTRLTPRECE  DATETIME;
  DECLARE @V_TIPOCALC      VARCHAR(1);
  DECLARE @V_CDFILIAL      VARCHAR(4);
  DECLARE @V_IDTPRECE      VARCHAR(1);
  DECLARE @V_REGMENORIGUAL NUMERIC;
  DECLARE @V_VRMOVTPRECE   FLOAT;
  DECLARE @V_VRSALTPRECE   FLOAT;
  DECLARE @V_MAIORIGUAL    NUMERIC;
  DECLARE @V_VRSALDOATUAL  FLOAT;

BEGIN
   IF @P_CDLOJA = ' ' BEGIN
      SET @V_TIPOCALC = '2';
   END;
   IF @P_CDLOJA <> ' ' BEGIN
      SET @V_TIPOCALC = '1';
   END;

   IF (@V_TIPOCALC = '1') BEGIN
      /*Retorna a primeira data/hora a partir da data/hora informada (maior ou igual)*/
      SELECT
         @V_DTCTRLTPRECE = MIN(DTCTRLTPRECE)
      FROM
         CTRLTPRECEB
      WHERE
         (CDFILIAL      = @P_CDFILIAL) AND
         (CDLOJA        = @P_CDLOJA  ) AND
         (DTCTRLTPRECE >= @P_DATA    );

      /*Retorna o nmero de registros menores ou iguais  data/hora informada*/
      SELECT
         @V_REGMENORIGUAL = COUNT(DTCTRLTPRECE)
      FROM
         CTRLTPRECEB
      WHERE
         (CDFILIAL      = @P_CDFILIAL    ) AND
         (CDLOJA        = @P_CDLOJA      ) AND
         (DTCTRLTPRECE <= @V_DTCTRLTPRECE);

      /*Se a data/hora informada for a primeira o saldo ser atualizado com o valor do prprio registro*/
      IF (@V_REGMENORIGUAL = 1) BEGIN

         /*Seleciona o registro*/
         SELECT
            @V_CDFILIAL    = CDFILIAL   , @V_DTCTRLTPRECE = DTCTRLTPRECE,
            @V_VRMOVTPRECE = VRMOVTPRECE, @V_IDTPRECE     = IDTPRECE    ,
            @V_VRSALTPRECE = VRSALTPRECE
         FROM
            CTRLTPRECEB
         WHERE
            (CDFILIAL     = @P_CDFILIAL    ) AND
            (CDLOJA       = @P_CDLOJA      ) AND
            (DTCTRLTPRECE = @V_DTCTRLTPRECE);

         IF (@V_IDTPRECE = 'D') BEGIN
            SET @V_VRMOVTPRECE = (-1) * @V_VRMOVTPRECE;
         END;


         /*Grava no valor do saldo, o valor da venda, visto que no h registro anterior*/
         UPDATE
            CTRLTPRECEB
         SET
            VRSALTPRECE  = @V_VRMOVTPRECE
         WHERE
            (DTCTRLTPRECE = @V_DTCTRLTPRECE) AND
            (CDLOJA       = @P_CDLOJA      ) AND
            (CDFILIAL     = @V_CDFILIAL    );

         /*Retorna o nmero de registros maiores ou iguais  data/hora informada*/
         SELECT
            @V_MAIORIGUAL = COUNT(DTCTRLTPRECE)
         FROM
            CTRLTPRECEB
         WHERE
            (CDFILIAL      = @P_CDFILIAL    ) AND
            (CDLOJA        = @P_CDLOJA      ) AND
            (DTCTRLTPRECE >= @V_DTCTRLTPRECE)

         /*Atualiza registross posteriores*/
         IF (@V_MAIORIGUAL > 1) BEGIN
            DECLARE CUR_CTRLTPRECEB CURSOR FOR
            SELECT
               CDFILIAL, DTCTRLTPRECE, VRMOVTPRECE, IDTPRECE, VRSALTPRECE
            FROM
               CTRLTPRECEB
            WHERE
               (CDFILIAL      = @P_CDFILIAL    ) AND
               (CDLOJA        = @P_CDLOJA      ) AND
               (DTCTRLTPRECE >= @V_DTCTRLTPRECE)
            ORDER BY
               DTCTRLTPRECE
            OPEN CUR_CTRLTPRECEB;
            FETCH NEXT FROM CUR_CTRLTPRECEB INTO @V_CDFILIAL    , @V_DTCTRLTPRECE,
                                                 @V_VRMOVTPRECE , @V_IDTPRECE    ,
                                                 @V_VRSALTPRECE;
            WHILE (@@FETCH_STATUS = 0) BEGIN

               SET @V_VRMOVTPRECE  = @V_VRMOVTPRECE;

               IF @V_IDTPRECE = 'D' BEGIN
                  SET @V_VRMOVTPRECE  = (-1) * @V_VRMOVTPRECE;
               END

              /*raise_application_error(-20504, CUR_CTRLTPRECEB.DTCTRLTPRECE, True);*/

              /*Retorna o saldo imediatamente anterior*/
               SELECT
                  @V_VRSALDOATUAL = (ISNULL(MAX(@V_VRSALTPRECE),0) + @V_VRMOVTPRECE)
               FROM
                  CTRLTPRECEB
               WHERE
                  (CDFILIAL      = @P_CDFILIAL) AND
                  (CDLOJA        = @P_CDLOJA  ) AND
                  (DTCTRLTPRECE  = (SELECT
                                      MAX(DTCTRLTPRECE)
                                   FROM
                                      CTRLTPRECEB
                                   WHERE
                                      (CDFILIAL     = @P_CDFILIAL      ) AND
                                      (CDLOJA       = @P_CDLOJA        ) AND
                                      (DTCTRLTPRECE < @V_DTCTRLTPRECE)));

               /*Atualiza os registros*/
               UPDATE
                  CTRLTPRECEB
               SET
                  VRSALTPRECE  = @V_VRSALDOATUAL
               WHERE
                  (CDFILIAL     = @P_CDFILIAL) AND
                  (CDLOJA       = @P_CDLOJA  ) AND
                  (DTCTRLTPRECE = @V_DTCTRLTPRECE);
               FETCH NEXT FROM CUR_CTRLTPRECEB INTO @V_CDFILIAL    , @V_DTCTRLTPRECE,
                                                    @V_VRMOVTPRECE , @V_IDTPRECE    ,
                                                    @V_VRSALTPRECE;
            END;
            CLOSE CUR_CTRLTPRECEB;
            DEALLOCATE CUR_CTRLTPRECEB;
         END;
      END;

      IF (@V_REGMENORIGUAL > 1) BEGIN
         /*Seleciona os registros a partir do atual.*/
         DECLARE CUR_CTRLTPRECEB CURSOR FOR
         SELECT
            CDFILIAL, DTCTRLTPRECE, VRMOVTPRECE, IDTPRECE, VRSALTPRECE
         FROM
            CTRLTPRECEB
         WHERE
            (CDFILIAL      = @P_CDFILIAL    ) AND
            (CDLOJA        = @P_CDLOJA      ) AND
            (DTCTRLTPRECE >= @V_DTCTRLTPRECE)
         ORDER BY
            DTCTRLTPRECE
         OPEN CUR_CTRLTPRECEB;
         FETCH NEXT FROM CUR_CTRLTPRECEB INTO @V_CDFILIAL   , @V_DTCTRLTPRECE,
                                              @V_VRMOVTPRECE, @V_IDTPRECE,
                                              @V_VRSALTPRECE;
         WHILE (@@FETCH_STATUS = 0) BEGIN

            /*qrySaldoAnte*/
            SET @V_VRMOVTPRECE  = @V_VRMOVTPRECE;

            IF @V_IDTPRECE = 'D' BEGIN
               SET @V_VRMOVTPRECE  = (-1) * @V_VRMOVTPRECE;
            END;

            SELECT
               @V_VRSALDOATUAL = (ISNULL(MAX(@V_VRSALTPRECE),0)  + @V_VRMOVTPRECE)
            FROM
               CTRLTPRECEB
            WHERE
               (CDFILIAL     = @P_CDFILIAL) AND
               (CDLOJA       = @P_CDLOJA  ) AND
               (DTCTRLTPRECE = (SELECT
                                    MAX(DTCTRLTPRECE)
                                 FROM
                                    CTRLTPRECEB
                                 WHERE
                                    (CDFILIAL     = @P_CDFILIAL) AND
                                    (CDLOJA       = @P_CDLOJA  ) AND
                                    (DTCTRLTPRECE < @V_DTCTRLTPRECE)));

            /*qryAtualiza*/
            UPDATE
               CTRLTPRECEB
            SET
               VRSALTPRECE  = @V_VRSALDOATUAL
            WHERE
               (CDFILIAL     = @P_CDFILIAL) AND
               (CDLOJA       = @P_CDLOJA  ) AND
               (DTCTRLTPRECE = @V_DTCTRLTPRECE);
            FETCH NEXT FROM CUR_CTRLTPRECEB INTO @V_CDFILIAL   , @V_DTCTRLTPRECE,
                                                 @V_VRMOVTPRECE, @V_IDTPRECE,
                                                 @V_VRSALTPRECE;
         END;
         CLOSE CUR_CTRLTPRECEB;
         DEALLOCATE CUR_CTRLTPRECEB;
      END;
   END;

   IF (@V_TIPOCALC = '2') BEGIN
      /*Retorna a primeira data/hora a partir da data/hora informada (maior ou igual)*/
      SELECT
         @V_DTCTRLTPRECE = MIN(DTCTRLTPRECE)
      FROM
         CTRLTPRECEB
      WHERE
         (CDFILIAL      = @P_CDFILIAL) AND
         (CDLOJA        IS NULL     ) AND
         (DTCTRLTPRECE >= @P_DATA    );

      /*Retorna o nmero de registros menores ou iguais  data/hora informada*/
      SELECT
         @V_REGMENORIGUAL = COUNT(DTCTRLTPRECE)
      FROM
         CTRLTPRECEB
      WHERE
         (CDFILIAL      = @P_CDFILIAL    ) AND
         (CDLOJA        IS NULL         ) AND
         (DTCTRLTPRECE <= @V_DTCTRLTPRECE);

      /*Se a data/hora informada for a primeira o saldo ser atualizado com o valor do prprio registro*/
      IF (@V_REGMENORIGUAL = 1) BEGIN

         /*Seleciona o registro*/
         SELECT
            @V_CDFILIAL    = CDFILIAL   , @V_DTCTRLTPRECE = DTCTRLTPRECE,
            @V_VRMOVTPRECE = VRMOVTPRECE, @V_IDTPRECE     = IDTPRECE    ,
            @V_VRSALTPRECE = VRSALTPRECE
         FROM
            CTRLTPRECEB
         WHERE
            (CDFILIAL     = @P_CDFILIAL    ) AND
            (CDLOJA       IS NULL          ) AND
            (DTCTRLTPRECE = @V_DTCTRLTPRECE);

         IF (@V_IDTPRECE = 'D') BEGIN
            SET @V_VRMOVTPRECE = (-1) * @V_VRMOVTPRECE;
         END ;

         /*Grava no valor do saldo, o valor da venda, visto que no h registro anterior*/
         UPDATE
            CTRLTPRECEB
         SET
            VRSALTPRECE  = @V_VRMOVTPRECE
         WHERE
            (DTCTRLTPRECE = @V_DTCTRLTPRECE) AND
            (CDLOJA        IS NULL         ) AND
            (CDFILIAL     = @V_CDFILIAL    );

         /*Retorna o nmero de registros maiores ou iguais  data/hora informada*/
         SELECT
           @V_MAIORIGUAL = COUNT(DTCTRLTPRECE)
         FROM
            CTRLTPRECEB
         WHERE
            (CDFILIAL      = @P_CDFILIAL    ) AND
            (CDLOJA        IS NULL         ) AND
            (DTCTRLTPRECE >= @V_DTCTRLTPRECE);

         /*Atualiza registross posteriores*/
         IF (@V_MAIORIGUAL > 1) BEGIN
            DECLARE CUR_CTRLTPRECEB CURSOR FOR
            SELECT
               CDFILIAL, DTCTRLTPRECE, VRMOVTPRECE, IDTPRECE, VRSALTPRECE
            FROM
               CTRLTPRECEB
            WHERE
               (CDFILIAL      = @P_CDFILIAL    ) AND
               (CDLOJA        IS NULL          ) AND
               (DTCTRLTPRECE >= @V_DTCTRLTPRECE)
            ORDER BY
               DTCTRLTPRECE
            OPEN CUR_CTRLTPRECEB;
            FETCH NEXT FROM CUR_CTRLTPRECEB INTO @V_CDFILIAL   , @V_DTCTRLTPRECE,
                                                 @V_VRMOVTPRECE, @V_IDTPRECE,
                                                 @V_VRSALTPRECE
            WHILE (@@FETCH_STATUS = 0) BEGIN

            SET @V_VRMOVTPRECE  = @V_VRMOVTPRECE;

               IF (@V_IDTPRECE = 'D') BEGIN
                  SET @V_VRMOVTPRECE  = (-1) * @V_VRMOVTPRECE;
               END;

               /*raise_application_error(-20504, CUR_CTRLTPRECEB.DTCTRLTPRECE, True);*/

               /*Retorna o saldo imediatamente anterior*/
               SELECT
                  @V_VRSALDOATUAL = (ISNULL(MAX(@V_VRSALTPRECE),0) + @V_VRMOVTPRECE)
               FROM
                  CTRLTPRECEB
               WHERE
                  (CDFILIAL      = @P_CDFILIAL) AND
			         (CDLOJA        IS NULL     ) AND
                  (DTCTRLTPRECE  = (SELECT
                                      MAX(DTCTRLTPRECE)
                                    FROM
                                       CTRLTPRECEB
                                    WHERE
                                      (CDFILIAL     = @P_CDFILIAL        ) AND
	        		                       (CDLOJA        IS NULL             ) AND
                                      (DTCTRLTPRECE < @V_DTCTRLTPRECE  )));

               /*Atualiza os registross*/
               UPDATE
                  CTRLTPRECEB
               SET
                  VRSALTPRECE  = @V_VRSALDOATUAL
               WHERE
                  (CDFILIAL     = @P_CDFILIAL) AND
			         (CDLOJA        IS NULL    ) AND
                  (DTCTRLTPRECE = @V_DTCTRLTPRECE);
               FETCH NEXT FROM CUR_CTRLTPRECEB INTO @V_CDFILIAL   , @V_DTCTRLTPRECE,
                                                    @V_VRMOVTPRECE, @V_IDTPRECE,
                                                    @V_VRSALTPRECE
            END;
            CLOSE CUR_CTRLTPRECEB;
            DEALLOCATE CUR_CTRLTPRECEB;
         END;
      END;

      IF (@V_REGMENORIGUAL > 1) BEGIN
         /*Seleciona os registros a partir do atual.*/
         DECLARE CUR_CTRLTPRECEB CURSOR FOR
         SELECT
            CDFILIAL, DTCTRLTPRECE, VRMOVTPRECE, IDTPRECE, VRSALTPRECE
         FROM
            CTRLTPRECEB
         WHERE
            (CDFILIAL      = @P_CDFILIAL    ) AND
            (CDLOJA        IS NULL          ) AND
            (DTCTRLTPRECE >= @V_DTCTRLTPRECE)
         ORDER BY
         DTCTRLTPRECE
         OPEN CUR_CTRLTPRECEB;
         FETCH NEXT FROM CUR_CTRLTPRECEB INTO @V_CDFILIAL   , @V_DTCTRLTPRECE,
                                              @V_VRMOVTPRECE, @V_IDTPRECE    ,
                                              @V_VRSALTPRECE
         WHILE (@@FETCH_STATUS = 0) BEGIN

            /*qrySaldoAnte*/
            SET @V_VRMOVTPRECE = @V_VRMOVTPRECE;

            IF @V_IDTPRECE = 'D' BEGIN
               SET @V_VRMOVTPRECE  = (-1) * @V_VRMOVTPRECE;
            END;

            SELECT
               @V_VRSALDOATUAL = (ISNULL(MAX(@V_VRSALTPRECE),0)  + @V_VRMOVTPRECE)
            FROM
               CTRLTPRECEB
            WHERE
               (CDFILIAL     = @P_CDFILIAL) AND
	            (CDLOJA        IS NULL    ) AND
               (DTCTRLTPRECE = (SELECT
                                    MAX(DTCTRLTPRECE)
                                 FROM
                                    CTRLTPRECEB
                                 WHERE
                                    (CDFILIAL     = @P_CDFILIAL) AND
                                    (CDLOJA        IS NULL    ) AND
                                    (DTCTRLTPRECE < @V_DTCTRLTPRECE)));

            /*qryAtualiza*/
            UPDATE
               CTRLTPRECEB
            SET
               VRSALTPRECE  = @V_VRSALDOATUAL
            WHERE
               (CDFILIAL     = @P_CDFILIAL) AND
   	         (CDLOJA        IS NULL    ) AND
               (DTCTRLTPRECE = @V_DTCTRLTPRECE);
            FETCH NEXT FROM CUR_CTRLTPRECEB INTO @V_CDFILIAL   , @V_DTCTRLTPRECE,
                                                 @V_VRMOVTPRECE, @V_IDTPRECE    ,
                                                 @V_VRSALTPRECE
            END;
            CLOSE CUR_CTRLTPRECEB;
            DEALLOCATE CUR_CTRLTPRECEB;
         END;
      END;
END;

